=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-10-10 19:26:05 +0000
+++ drizzled/Makefile.am	2009-10-16 00:38:56 +0000
@@ -16,7 +16,7 @@
 
 sbin_PROGRAMS= drizzled
 
-DTRACEFILES = handler.o \
+DTRACEFILES = cursor.o \
 	      filesort.o \
 	      drizzled.o \
 	      session.o \
@@ -190,7 +190,7 @@
 		function_hash.h \
 		ha_statistics.h \
 		ha_trx_info.h \
-		handler.h \
+		cursor.h \
 		handler_structs.h \
 		hybrid_type.h \
 		hybrid_type_traits.h \
@@ -707,7 +707,7 @@
 libserialutil_la_SOURCES = db.cc table_proto_write.cc
 libserialutil_la_CXXFLAGS= ${AM_CXXFLAGS} ${PROTOSKIP_WARNINGS}
 
-libhandler_la_SOURCES = handler.cc plugin/storage_engine.cc
+libhandler_la_SOURCES = cursor.cc plugin/storage_engine.cc
 
 AM_YFLAGS = -p DRIZZLE -d --verbose
 

=== renamed file 'drizzled/handler.cc' => 'drizzled/cursor.cc'
--- drizzled/handler.cc	2009-10-15 19:04:03 +0000
+++ drizzled/cursor.cc	2009-10-16 00:38:56 +0000
@@ -18,7 +18,7 @@
  */
 
 /**
-  @file handler.cc
+  @file Cursor.cc
 
   Handler-calling-functions
 */
@@ -66,7 +66,7 @@
 
 
 /**
-  Register handler error messages for use with my_error().
+  Register Cursor error messages for use with my_error().
 
   @retval
     0           OK
@@ -92,7 +92,7 @@
   SETMSG(HA_ERR_WRONG_INDEX,            "Wrong index given to function");
   SETMSG(HA_ERR_CRASHED,                ER(ER_NOT_KEYFILE));
   SETMSG(HA_ERR_WRONG_IN_RECORD,        ER(ER_CRASHED_ON_USAGE));
-  SETMSG(HA_ERR_OUT_OF_MEM,             "Table handler out of memory");
+  SETMSG(HA_ERR_OUT_OF_MEM,             "Table Cursor out of memory");
   SETMSG(HA_ERR_NOT_A_TABLE,            "Incorrect file format '%.64s'");
   SETMSG(HA_ERR_WRONG_COMMAND,          "Command not supported");
   SETMSG(HA_ERR_OLD_FILE,               ER(ER_OLD_KEYFILE));
@@ -134,7 +134,7 @@
 
 
 /**
-  Unregister handler error messages.
+  Unregister Cursor error messages.
 
   @retval
     0           OK
@@ -391,7 +391,7 @@
   in it unless the engine says so. Thus, in order to be
   a part of a transaction, the engine must "register" itself.
   This is done by invoking trans_register_ha() server call.
-  Normally the engine registers itself whenever handler::external_lock()
+  Normally the engine registers itself whenever Cursor::external_lock()
   is called. trans_register_ha() can be invoked many times: if
   an engine is already registered, the call does nothing.
   In case autocommit is not set, the engine must register itself
@@ -402,12 +402,12 @@
   Note, that although the registration interface in itself is
   fairly clear, the current usage practice often leads to undesired
   effects. E.g. since a call to trans_register_ha() in most engines
-  is embedded into implementation of handler::external_lock(), some
+  is embedded into implementation of Cursor::external_lock(), some
   DDL statements start a transaction (at least from the server
   point of view) even though they are not expected to. E.g.
   CREATE TABLE does not start a transaction, since
-  handler::external_lock() is never called during CREATE TABLE. But
-  CREATE TABLE ... SELECT does, since handler::external_lock() is
+  Cursor::external_lock() is never called during CREATE TABLE. But
+  CREATE TABLE ... SELECT does, since Cursor::external_lock() is
   called for the table that is being selected from. This has no
   practical effects currently, but must be kept in mind
   nevertheless.
@@ -416,8 +416,8 @@
   of the work.
 
   During statement execution, whenever any of data-modifying
-  PSEA API methods is used, e.g. handler::write_row() or
-  handler::update_row(), the read-write flag is raised in the
+  PSEA API methods is used, e.g. Cursor::write_row() or
+  Cursor::update_row(), the read-write flag is raised in the
   statement transaction for the involved engine.
   Currently All PSEA calls are "traced", and the data can not be
   changed in a way other than issuing a PSEA call. Important:
@@ -943,22 +943,22 @@
 
 
 /****************************************************************************
-** General handler functions
+** General Cursor functions
 ****************************************************************************/
-handler::~handler(void)
+Cursor::~Cursor(void)
 {
   assert(locked == false);
   /* TODO: assert(inited == NONE); */
 }
 
 
-handler *handler::clone(MEM_ROOT *mem_root)
+Cursor *Cursor::clone(MEM_ROOT *mem_root)
 {
-  handler *new_handler= table->s->db_type()->getCursor(table->s, mem_root);
+  Cursor *new_handler= table->s->db_type()->getCursor(table->s, mem_root);
   /*
-    Allocate handler->ref here because otherwise ha_open will allocate it
+    Allocate Cursor->ref here because otherwise ha_open will allocate it
     on this->table->mem_root and we will not be able to reclaim that memory
-    when the clone handler object is destroyed.
+    when the clone Cursor object is destroyed.
   */
   if (!(new_handler->ref= (unsigned char*) alloc_root(mem_root, ALIGN_SIZE(ref_length)*2)))
     return NULL;
@@ -970,7 +970,7 @@
   return NULL;
 }
 
-int handler::ha_index_init(uint32_t idx, bool sorted)
+int Cursor::ha_index_init(uint32_t idx, bool sorted)
 {
   int result;
   assert(inited == NONE);
@@ -980,7 +980,7 @@
   return result;
 }
 
-int handler::ha_index_end()
+int Cursor::ha_index_end()
 {
   assert(inited==INDEX);
   inited=NONE;
@@ -988,7 +988,7 @@
   return(index_end());
 }
 
-int handler::ha_rnd_init(bool scan)
+int Cursor::ha_rnd_init(bool scan)
 {
   int result;
   assert(inited==NONE || (inited==RND && scan));
@@ -997,69 +997,69 @@
   return result;
 }
 
-int handler::ha_rnd_end()
+int Cursor::ha_rnd_end()
 {
   assert(inited==RND);
   inited=NONE;
   return(rnd_end());
 }
 
-int handler::ha_index_or_rnd_end()
+int Cursor::ha_index_or_rnd_end()
 {
   return inited == INDEX ? ha_index_end() : inited == RND ? ha_rnd_end() : 0;
 }
 
-handler::Table_flags handler::ha_table_flags() const
+Cursor::Table_flags Cursor::ha_table_flags() const
 {
   return cached_table_flags;
 }
 
-void handler::ha_start_bulk_insert(ha_rows rows)
+void Cursor::ha_start_bulk_insert(ha_rows rows)
 {
   estimation_rows_to_insert= rows;
   start_bulk_insert(rows);
 }
 
-int handler::ha_end_bulk_insert()
+int Cursor::ha_end_bulk_insert()
 {
   estimation_rows_to_insert= 0;
   return end_bulk_insert();
 }
 
-void handler::change_table_ptr(Table *table_arg, TableShare *share)
+void Cursor::change_table_ptr(Table *table_arg, TableShare *share)
 {
   table= table_arg;
   table_share= share;
 }
 
-const key_map *handler::keys_to_use_for_scanning()
+const key_map *Cursor::keys_to_use_for_scanning()
 {
   return &key_map_empty;
 }
 
-bool handler::has_transactions()
+bool Cursor::has_transactions()
 {
   return (ha_table_flags() & HA_NO_TRANSACTIONS) == 0;
 }
 
-void handler::ha_statistic_increment(ulong SSV::*offset) const
+void Cursor::ha_statistic_increment(ulong SSV::*offset) const
 {
   status_var_increment(table->in_use->status_var.*offset);
 }
 
-void **handler::ha_data(Session *session) const
+void **Cursor::ha_data(Session *session) const
 {
   return session_ha_data(session, engine);
 }
 
-Session *handler::ha_session(void) const
+Session *Cursor::ha_session(void) const
 {
   assert(!table || !table->in_use || table->in_use == current_session);
   return (table && table->in_use) ? table->in_use : current_session;
 }
 
 
-bool handler::is_fatal_error(int error, uint32_t flags)
+bool Cursor::is_fatal_error(int error, uint32_t flags)
 {
   if (!error ||
       ((flags & HA_CHECK_DUP_KEY) &&
@@ -1070,15 +1070,15 @@
 }
 
 
-ha_rows handler::records() { return stats.records; }
+ha_rows Cursor::records() { return stats.records; }
 
 /**
-  Open database-handler.
+  Open database-Cursor.
 
   Try O_RDONLY if cannot open as O_RDWR
   Don't wait for locks if not HA_OPEN_WAIT_IF_LOCKED is set
 */
-int handler::ha_open(Table *table_arg, const char *name, int mode,
+int Cursor::ha_open(Table *table_arg, const char *name, int mode,
                      int test_if_locked)
 {
   int error;
@@ -1106,7 +1106,7 @@
       table->db_stat|=HA_READ_ONLY;
     (void) extra(HA_EXTRA_NO_READCHECK);	// Not needed in SQL
 
-    /* ref is already allocated for us if we're called from handler::clone() */
+    /* ref is already allocated for us if we're called from Cursor::clone() */
     if (!ref && !(ref= (unsigned char*) alloc_root(&table->mem_root,
                                           ALIGN_SIZE(ref_length)*2)))
     {
@@ -1127,7 +1127,7 @@
   handlers for random position
 */
 
-int handler::rnd_pos_by_record(unsigned char *record)
+int Cursor::rnd_pos_by_record(unsigned char *record)
 {
   register int error;
 
@@ -1146,7 +1146,7 @@
   This is never called for InnoDB tables, as these table types
   has the HA_STATS_RECORDS_IS_EXACT set.
 */
-int handler::read_first_row(unsigned char * buf, uint32_t primary_key)
+int Cursor::read_first_row(unsigned char * buf, uint32_t primary_key)
 {
   register int error;
 
@@ -1198,7 +1198,7 @@
 }
 
 
-void handler::adjust_next_insert_id_after_explicit_value(uint64_t nr)
+void Cursor::adjust_next_insert_id_after_explicit_value(uint64_t nr)
 {
   /*
     If we have set Session::next_insert_id previously and plan to insert an
@@ -1272,7 +1272,7 @@
     reserved for us.
 
   - In both cases, for the following rows we use those reserved values without
-    calling the handler again (we just progress in the interval, computing
+    calling the Cursor again (we just progress in the interval, computing
     each new value from the previous one). Until we have exhausted them, then
     we either take the next provided interval or call get_auto_increment()
     again to reserve a new interval.
@@ -1319,7 +1319,7 @@
 #define AUTO_INC_DEFAULT_NB_MAX_BITS 16
 #define AUTO_INC_DEFAULT_NB_MAX ((1 << AUTO_INC_DEFAULT_NB_MAX_BITS) - 1)
 
-int handler::update_auto_increment()
+int Cursor::update_auto_increment()
 {
   uint64_t nr, nb_reserved_values;
   bool append= false;
@@ -1364,8 +1364,8 @@
     else
     {
       /*
-        handler::estimation_rows_to_insert was set by
-        handler::ha_start_bulk_insert(); if 0 it means "unknown".
+        Cursor::estimation_rows_to_insert was set by
+        Cursor::ha_start_bulk_insert(); if 0 it means "unknown".
       */
       uint32_t nb_already_reserved_intervals=
         session->auto_inc_intervals_in_cur_stmt_for_binlog.nb_elements();
@@ -1467,7 +1467,7 @@
 
 
 /**
-  Reserves an interval of auto_increment values from the handler.
+  Reserves an interval of auto_increment values from the Cursor.
 
   offset and increment means that we want values to be of the form
   offset + N * increment, where N>=0 is integer.
@@ -1478,10 +1478,10 @@
   @param offset
   @param increment
   @param nb_desired_values   how many values we want
-  @param first_value         (OUT) the first value reserved by the handler
-  @param nb_reserved_values  (OUT) how many values the handler reserved
+  @param first_value         (OUT) the first value reserved by the Cursor
+  @param nb_reserved_values  (OUT) how many values the Cursor reserved
 */
-void handler::get_auto_increment(uint64_t ,
+void Cursor::get_auto_increment(uint64_t ,
                                  uint64_t ,
                                  uint64_t ,
                                  uint64_t *first_value,
@@ -1498,8 +1498,8 @@
     error=index_last(table->record[1]);
     /*
       MySQL implicitely assumes such method does locking (as MySQL decides to
-      use nr+increment without checking again with the handler, in
-      handler::update_auto_increment()), so reserves to infinite.
+      use nr+increment without checking again with the Cursor, in
+      Cursor::update_auto_increment()), so reserves to infinite.
     */
     *nb_reserved_values= UINT64_MAX;
   }
@@ -1532,7 +1532,7 @@
 }
 
 
-void handler::ha_release_auto_increment()
+void Cursor::ha_release_auto_increment()
 {
   release_auto_increment();
   insert_id_for_cur_row= 0;
@@ -1549,7 +1549,7 @@
 }
 
 
-void handler::print_keydup_error(uint32_t key_nr, const char *msg)
+void Cursor::print_keydup_error(uint32_t key_nr, const char *msg)
 {
   /* Write the duplicated key in the error message */
   char key[MAX_KEY_LENGTH];
@@ -1578,7 +1578,7 @@
 
 
 /**
-  Print error that we got from handler function.
+  Print error that we got from Cursor function.
 
   @note
     In case of delete table it's only safe to use the following parts of
@@ -1586,7 +1586,7 @@
     - table->s->path
     - table->alias
 */
-void handler::print_error(int error, myf errflag)
+void Cursor::print_error(int error, myf errflag)
 {
   int textno=ER_GET_ERRNO;
   switch (error) {
@@ -1747,7 +1747,7 @@
   default:
     {
       /* The error was "unknown" to this function.
-	 Ask handler if it has got a message for this error */
+	 Ask Cursor if it has got a message for this error */
       bool temporary= false;
       String str;
       temporary= get_error_message(error, &str);
@@ -1772,22 +1772,22 @@
 
 
 /**
-  Return an error message specific to this handler.
+  Return an error message specific to this Cursor.
 
-  @param error  error code previously returned by handler
+  @param error  error code previously returned by Cursor
   @param buf    pointer to String where to add error message
 
   @return
     Returns true if this is a temporary error
 */
-bool handler::get_error_message(int , String* )
+bool Cursor::get_error_message(int , String* )
 {
   return false;
 }
 
 
 /* Code left, but Drizzle has no legacy yet (while MySQL did) */
-int handler::check_old_types()
+int Cursor::check_old_types()
 {
   return 0;
 }
@@ -1796,7 +1796,7 @@
   @return
     key if error because of duplicated keys
 */
-uint32_t handler::get_dup_key(int error)
+uint32_t Cursor::get_dup_key(int error)
 {
   table->file->errkey  = (uint32_t) -1;
   if (error == HA_ERR_FOUND_DUPP_KEY || error == HA_ERR_FOREIGN_DUPLICATE_KEY ||
@@ -1806,7 +1806,7 @@
   return(table->file->errkey);
 }
 
-void handler::drop_table(const char *)
+void Cursor::drop_table(const char *)
 {
   close();
 }
@@ -1827,7 +1827,7 @@
   @retval
     HA_ADMIN_NOT_IMPLEMENTED
 */
-int handler::ha_check(Session *, HA_CHECK_OPT *)
+int Cursor::ha_check(Session *, HA_CHECK_OPT *)
 {
   return HA_ADMIN_OK;
 }
@@ -1839,7 +1839,7 @@
 
 inline
 void
-handler::mark_trx_read_write()
+Cursor::mark_trx_read_write()
 {
   Ha_trx_info *ha_info= &ha_session()->ha_data[engine->getSlot()].ha_info[0];
   /*
@@ -1859,11 +1859,11 @@
 /**
   Bulk update row: public interface.
 
-  @sa handler::bulk_update_row()
+  @sa Cursor::bulk_update_row()
 */
 
 int
-handler::ha_bulk_update_row(const unsigned char *old_data, unsigned char *new_data,
+Cursor::ha_bulk_update_row(const unsigned char *old_data, unsigned char *new_data,
                             uint32_t *dup_key_found)
 {
   mark_trx_read_write();
@@ -1875,11 +1875,11 @@
 /**
   Delete all rows: public interface.
 
-  @sa handler::delete_all_rows()
+  @sa Cursor::delete_all_rows()
 */
 
 int
-handler::ha_delete_all_rows()
+Cursor::ha_delete_all_rows()
 {
   mark_trx_read_write();
 
@@ -1890,11 +1890,11 @@
 /**
   Reset auto increment: public interface.
 
-  @sa handler::reset_auto_increment()
+  @sa Cursor::reset_auto_increment()
 */
 
 int
-handler::ha_reset_auto_increment(uint64_t value)
+Cursor::ha_reset_auto_increment(uint64_t value)
 {
   mark_trx_read_write();
 
@@ -1905,11 +1905,11 @@
 /**
   Optimize table: public interface.
 
-  @sa handler::optimize()
+  @sa Cursor::optimize()
 */
 
 int
-handler::ha_optimize(Session* session, HA_CHECK_OPT* check_opt)
+Cursor::ha_optimize(Session* session, HA_CHECK_OPT* check_opt)
 {
   mark_trx_read_write();
 
@@ -1920,11 +1920,11 @@
 /**
   Analyze table: public interface.
 
-  @sa handler::analyze()
+  @sa Cursor::analyze()
 */
 
 int
-handler::ha_analyze(Session* session, HA_CHECK_OPT* check_opt)
+Cursor::ha_analyze(Session* session, HA_CHECK_OPT* check_opt)
 {
   mark_trx_read_write();
 
@@ -1934,11 +1934,11 @@
 /**
   Disable indexes: public interface.
 
-  @sa handler::disable_indexes()
+  @sa Cursor::disable_indexes()
 */
 
 int
-handler::ha_disable_indexes(uint32_t mode)
+Cursor::ha_disable_indexes(uint32_t mode)
 {
   mark_trx_read_write();
 
@@ -1949,11 +1949,11 @@
 /**
   Enable indexes: public interface.
 
-  @sa handler::enable_indexes()
+  @sa Cursor::enable_indexes()
 */
 
 int
-handler::ha_enable_indexes(uint32_t mode)
+Cursor::ha_enable_indexes(uint32_t mode)
 {
   mark_trx_read_write();
 
@@ -1964,11 +1964,11 @@
 /**
   Discard or import tablespace: public interface.
 
-  @sa handler::discard_or_import_tablespace()
+  @sa Cursor::discard_or_import_tablespace()
 */
 
 int
-handler::ha_discard_or_import_tablespace(bool discard)
+Cursor::ha_discard_or_import_tablespace(bool discard)
 {
   mark_trx_read_write();
 
@@ -1978,11 +1978,11 @@
 /**
   Drop table in the engine: public interface.
 
-  @sa handler::drop_table()
+  @sa Cursor::drop_table()
 */
 
 void
-handler::closeMarkForDelete(const char *name)
+Cursor::closeMarkForDelete(const char *name)
 {
   mark_trx_read_write();
 
@@ -1991,7 +1991,7 @@
 
 /**
   Tell the storage engine that it is allowed to "disable transaction" in the
-  handler. It is a hint that ACID is not required - it is used in NDB for
+  Cursor. It is a hint that ACID is not required - it is used in NDB for
   ALTER Table, for example, when data are copied to temporary table.
   A storage engine may treat this hint any way it likes. NDB for example
   starts to commit every now and then automatically.
@@ -2017,7 +2017,7 @@
   return error;
 }
 
-int handler::index_next_same(unsigned char *buf, const unsigned char *key, uint32_t keylen)
+int Cursor::index_next_same(unsigned char *buf, const unsigned char *key, uint32_t keylen)
 {
   int error;
   if (!(error=index_next(buf)))
@@ -2069,7 +2069,7 @@
 
 
 /****************************************************************************
-** Some general functions that isn't in the handler class
+** Some general functions that isn't in the Cursor class
 ****************************************************************************/
 
 
@@ -2088,19 +2088,19 @@
   @note
     It is assumed that we will read trough the whole key range and that all
     key blocks are half full (normally things are much better). It is also
-    assumed that each time we read the next key from the index, the handler
+    assumed that each time we read the next key from the index, the Cursor
     performs a random seek, thus the cost is proportional to the number of
     blocks read.
 
   @todo
-    Consider joining this function and handler::read_time() into one
-    handler::read_time(keynr, records, ranges, bool index_only) function.
+    Consider joining this function and Cursor::read_time() into one
+    Cursor::read_time(keynr, records, ranges, bool index_only) function.
 
   @return
     Estimated cost of 'index only' scan
 */
 
-double handler::index_only_read_time(uint32_t keynr, double key_records)
+double Cursor::index_only_read_time(uint32_t keynr, double key_records)
 {
   uint32_t keys_per_block= (stats.block_size/2/
 			(table->key_info[keynr].key_length + ref_length) + 1);
@@ -2145,7 +2145,7 @@
 */
 
 ha_rows
-handler::multi_range_read_info_const(uint32_t keyno, RANGE_SEQ_IF *seq,
+Cursor::multi_range_read_info_const(uint32_t keyno, RANGE_SEQ_IF *seq,
                                      void *seq_init_param,
                                      uint32_t ,
                                      uint32_t *bufsz, uint32_t *flags, COST_VECT *cost)
@@ -2236,7 +2236,7 @@
     other Error or can't perform the requested scan
 */
 
-int handler::multi_range_read_info(uint32_t keyno, uint32_t n_ranges, uint32_t n_rows,
+int Cursor::multi_range_read_info(uint32_t keyno, uint32_t n_ranges, uint32_t n_rows,
                                    uint32_t *bufsz, uint32_t *flags, COST_VECT *cost)
 {
   *bufsz= 0; /* Default implementation doesn't need a buffer */
@@ -2281,7 +2281,7 @@
     also hold:
     The caller will guarantee that if "seq->init == mrr_ranges_array_init"
     then seq_init_param is an array of n_ranges KEY_MULTI_RANGE structures.
-    This property will only be used by NDB handler until WL#2623 is done.
+    This property will only be used by NDB Cursor until WL#2623 is done.
 
     Buffer memory management is done according to the following scenario:
     The caller allocates the buffer and provides it to the callee by filling
@@ -2297,7 +2297,7 @@
 */
 
 int
-handler::multi_range_read_init(RANGE_SEQ_IF *seq_funcs, void *seq_init_param,
+Cursor::multi_range_read_init(RANGE_SEQ_IF *seq_funcs, void *seq_init_param,
                                uint32_t n_ranges, uint32_t mode,
                                HANDLER_BUFFER *)
 {
@@ -2322,7 +2322,7 @@
   @retval other  Error code
 */
 
-int handler::multi_range_read_next(char **range_info)
+int Cursor::multi_range_read_next(char **range_info)
 {
   int result= 0;
   int range_res= 0;
@@ -2379,7 +2379,7 @@
 /**
   Get cost of reading nrows table records in a "disk sweep"
 
-  A disk sweep read is a sequence of handler->rnd_pos(rowid) calls that made
+  A disk sweep read is a sequence of Cursor->rnd_pos(rowid) calls that made
   for an ordered sequence of rowids.
 
   We assume hard disk IO. The read is performed as follows:
@@ -2471,7 +2471,7 @@
   @retval
     \#			Error code
 */
-int handler::read_range_first(const key_range *start_key,
+int Cursor::read_range_first(const key_range *start_key,
 			      const key_range *end_key,
 			      bool eq_range_arg,
                               bool )
@@ -2518,7 +2518,7 @@
   @retval
     \#			Error code
 */
-int handler::read_range_next()
+int Cursor::read_range_next()
 {
   int result;
 
@@ -2551,7 +2551,7 @@
     - -1  : Key is less than range
     - 1   : Key is larger than range
 */
-int handler::compare_key(key_range *range)
+int Cursor::compare_key(key_range *range)
 {
   int cmp;
   if (!range || in_range_check_pushed_down)
@@ -2568,7 +2568,7 @@
   This is used by index condition pushdown implementation.
 */
 
-int handler::compare_key2(key_range *range)
+int Cursor::compare_key2(key_range *range)
 {
   int cmp;
   if (!range)
@@ -2579,7 +2579,7 @@
   return cmp;
 }
 
-int handler::index_read_idx_map(unsigned char * buf, uint32_t index,
+int Cursor::index_read_idx_map(unsigned char * buf, uint32_t index,
                                 const unsigned char * key,
                                 key_part_map keypart_map,
                                 enum ha_rkey_function find_flag)
@@ -2641,7 +2641,7 @@
   return false; //error;
 }
 
-int handler::ha_external_lock(Session *session, int lock_type)
+int Cursor::ha_external_lock(Session *session, int lock_type)
 {
   /*
     Whether this is lock or unlock, this should be true, and is to verify that
@@ -2664,9 +2664,9 @@
 
 
 /**
-  Check handler usage and reset state of file to after 'open'
+  Check Cursor usage and reset state of file to after 'open'
 */
-int handler::ha_reset()
+int Cursor::ha_reset()
 {
   /* Check that we have called all proper deallocation functions */
   assert((unsigned char*) table->def_read_set.getBitmap() +
@@ -2684,7 +2684,7 @@
 }
 
 
-int handler::ha_write_row(unsigned char *buf)
+int Cursor::ha_write_row(unsigned char *buf)
 {
   int error;
 
@@ -2692,7 +2692,7 @@
    * If we have a timestamp column, update it to the current time 
    * 
    * @TODO Technically, the below two lines can be take even further out of the
-   * handler interface and into the fill_record() method.
+   * Cursor interface and into the fill_record() method.
    */
   if (table->timestamp_field_type & TIMESTAMP_AUTO_SET_ON_INSERT)
     table->timestamp_field->set_time();
@@ -2711,7 +2711,7 @@
 }
 
 
-int handler::ha_update_row(const unsigned char *old_data, unsigned char *new_data)
+int Cursor::ha_update_row(const unsigned char *old_data, unsigned char *new_data)
 {
   int error;
 
@@ -2734,7 +2734,7 @@
   return 0;
 }
 
-int handler::ha_delete_row(const unsigned char *buf)
+int Cursor::ha_delete_row(const unsigned char *buf)
 {
   int error;
 

=== renamed file 'drizzled/handler.h' => 'drizzled/cursor.h'
--- drizzled/handler.h	2009-10-09 19:51:23 +0000
+++ drizzled/cursor.h	2009-10-16 00:38:56 +0000
@@ -23,7 +23,7 @@
 #include <drizzled/xid.h>
 #include <drizzled/discrete_interval.h>
 
-/* Definitions for parameters to do with handler-routines */
+/* Definitions for parameters to do with Cursor-routines */
 
 #include <mysys/thr_lock.h>
 #include <mysys/hash.h>
@@ -39,7 +39,7 @@
 /* Bits to show what an alter table will do */
 #include <drizzled/sql_bitmap.h>
 
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 
 #include <bitset>
 #include <algorithm>
@@ -57,7 +57,7 @@
                                       uint64_t *engine_data);
 
 
-/* The handler for a table type.  Will be included in the Table structure */
+/* The Cursor for a table type.  Will be included in the Table structure */
 
 class Table;
 class TableList;
@@ -114,7 +114,7 @@
 }
 
 /**
-  The handler class is the interface for dynamically loadable
+  The Cursor class is the interface for dynamically loadable
   storage engines. Do not add ifdefs and take care when adding or
   changing virtual functions to avoid vtable confusion
 
@@ -161,7 +161,7 @@
   must be set to 0.
 */
 
-class handler :public Sql_alloc
+class Cursor :public Sql_alloc
 {
 public:
   typedef uint64_t Table_flags;
@@ -173,7 +173,7 @@
 
   ha_rows estimation_rows_to_insert;
 public:
-  drizzled::plugin::StorageEngine *engine;      /* storage engine of this handler */
+  drizzled::plugin::StorageEngine *engine;      /* storage engine of this Cursor */
   unsigned char *ref;		  		/* Pointer to current row */
   unsigned char *dup_ref;			/* Pointer to duplicate row */
 
@@ -236,7 +236,7 @@
   */
   Discrete_interval auto_inc_interval_for_cur_row;
 
-  handler(drizzled::plugin::StorageEngine *engine_arg, TableShare *share_arg)
+  Cursor(drizzled::plugin::StorageEngine *engine_arg, TableShare *share_arg)
     :table_share(share_arg), table(0),
     estimation_rows_to_insert(0), engine(engine_arg),
     ref(0), in_range_check_pushed_down(false),
@@ -246,8 +246,8 @@
     locked(false), implicit_emptied(0),
     next_insert_id(0), insert_id_for_cur_row(0)
     {}
-  virtual ~handler(void);
-  virtual handler *clone(MEM_ROOT *mem_root);
+  virtual ~Cursor(void);
+  virtual Cursor *clone(MEM_ROOT *mem_root);
   /** This is called after create to allow us to set up cached variables */
   void init()
   {
@@ -269,7 +269,7 @@
 
   /**
     These functions represent the public interface to *users* of the
-    handler class, hence they are *not* virtual. For the inheritance
+    Cursor class, hence they are *not* virtual. For the inheritance
     interface, see the (private) functions write_row(), update_row(),
     and delete_row() below.
   */
@@ -330,7 +330,7 @@
   /**
     This method is used to analyse the error to see whether the error
     is ignorable or not, certain handlers can have more error that are
-    ignorable than others. E.g. the partition handler can get inserts
+    ignorable than others. E.g. the partition Cursor can get inserts
     into a range where there is no partition and this is an ignorable
     error.
     HA_ERR_FOUND_DUP_UNIQUE is a special case in MyISAM that means the
@@ -367,12 +367,12 @@
   virtual int close(void)=0;
 
   /**
-    @retval  0   Bulk update used by handler
+    @retval  0   Bulk update used by Cursor
     @retval  1   Bulk update not used, normal operation used
   */
   virtual bool start_bulk_update() { return 1; }
   /**
-    @retval  0   Bulk delete used by handler
+    @retval  0   Bulk delete used by Cursor
     @retval  1   Bulk delete not used, normal operation used
   */
   virtual bool start_bulk_delete() { return 1; }
@@ -380,7 +380,7 @@
     After this call all outstanding updates must be performed. The number
     of duplicate key errors are reported in the duplicate key parameter.
     It is allowed to continue to the batched update after this call, the
-    handler has to wait until end_bulk_update with changing state.
+    Cursor has to wait until end_bulk_update with changing state.
 
     @param    dup_key_found       Number of duplicate keys found
 
@@ -561,7 +561,7 @@
   { return 0; }
   virtual uint32_t referenced_by_foreign_key() { return 0;}
   virtual void free_foreign_key_create_info(char *) {}
-  /** The following can be called without an open handler */
+  /** The following can be called without an open Cursor */
 
   virtual uint32_t index_flags(uint32_t idx, uint32_t part, bool all_parts) const =0;
 
@@ -707,8 +707,8 @@
     Is not invoked for non-transactional temporary tables.
 
     Tells the storage engine that we intend to read or write data
-    from the table. This call is prefixed with a call to handler::store_lock()
-    and is invoked only for those handler instances that stored the lock.
+    from the table. This call is prefixed with a call to Cursor::store_lock()
+    and is invoked only for those Cursor instances that stored the lock.
 
     Calls to rnd_init/index_init are prefixed with this call. When table
     IO is complete, we call external_lock(F_UNLCK).
@@ -743,8 +743,8 @@
   virtual int index_read_last(unsigned char *, const unsigned char *, uint32_t)
    { return (my_errno= HA_ERR_WRONG_COMMAND); }
   /**
-    This method is similar to update_row, however the handler doesn't need
-    to execute the updates at this point in time. The handler can be certain
+    This method is similar to update_row, however the Cursor doesn't need
+    to execute the updates at this point in time. The Cursor can be certain
     that another call to bulk_update_row will occur OR a call to
     exec_bulk_update before the set of updates in this query is concluded.
 
@@ -752,7 +752,7 @@
     @param    new_data       New record
     @param    dup_key_found  Number of duplicate keys found
 
-    @retval  0   Bulk delete used by handler
+    @retval  0   Bulk delete used by Cursor
     @retval  1   Bulk delete not used, normal operation used
   */
   virtual int bulk_update_row(const unsigned char *, unsigned char *, uint32_t *)
@@ -762,7 +762,7 @@
   }
   /**
     This is called to delete all rows in a table
-    If the handler don't support this, then this function will
+    If the Cursor don't support this, then this function will
     return HA_ERR_WRONG_COMMAND and MySQL will delete the rows one
     by one.
   */

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2009-10-01 17:56:07 +0000
+++ drizzled/filesort.cc	2009-10-16 00:38:56 +0000
@@ -454,13 +454,13 @@
   Table *sort_form;
   Session *session= current_session;
   volatile Session::killed_state *killed= &session->killed;
-  handler *file;
+  Cursor *file;
   MyBitmap *save_read_set, *save_write_set;
 
   idx=indexpos=0;
   error=quick_select=0;
   sort_form=param->sort_form;
-  file=sort_form->file;
+  file= sort_form->file;
   ref_length=param->ref_length;
   ref_pos= ref_buff;
   quick_select=select && select->quick;
@@ -1323,7 +1323,7 @@
 /**
   Calculate length of sort key.
 
-  @param session			  Thread handler
+  @param session			  Thread Cursor
   @param sortorder		  Order of items to sort
   @param s_length	          Number of items to sort
   @param[out] multi_byte_charset Set to 1 if we are using multi-byte charset

=== modified file 'drizzled/opt_range.cc'
--- drizzled/opt_range.cc	2009-10-08 06:16:39 +0000
+++ drizzled/opt_range.cc	2009-10-16 00:38:56 +0000
@@ -133,7 +133,7 @@
 
 extern "C" int refpos_order_cmp(void* arg, const void *a,const void *b)
 {
-  handler *file= (handler*)arg;
+  Cursor *file= (Cursor*)arg;
   return file->cmp_ref((const unsigned char*)a, (const unsigned char*)b);
 }
 
@@ -1156,7 +1156,7 @@
 
 int QUICK_RANGE_SELECT::init()
 {
-  if (file->inited != handler::NONE)
+  if (file->inited != Cursor::NONE)
     file->ha_index_or_rnd_end();
   return(file->ha_index_init(index, 1));
 }
@@ -1164,7 +1164,7 @@
 
 void QUICK_RANGE_SELECT::range_end()
 {
-  if (file->inited != handler::NONE)
+  if (file->inited != Cursor::NONE)
     file->ha_index_or_rnd_end();
 }
 
@@ -1291,13 +1291,13 @@
   SYNOPSIS
     QUICK_RANGE_SELECT::init_ror_merged_scan()
       reuse_handler If true, use head->file, otherwise create a separate
-                    handler object
+                    Cursor object
 
   NOTES
-    This function creates and prepares for subsequent use a separate handler
+    This function creates and prepares for subsequent use a separate Cursor
     object if it can't reuse head->file. The reason for this is that during
     ROR-merge several key scans are performed simultaneously, and a single
-    handler is only capable of preserving context of a single key scan.
+    Cursor is only capable of preserving context of a single key scan.
 
     In ROR-merge the quick select doing merge does full records retrieval,
     merged quick selects read only keys.
@@ -1309,7 +1309,7 @@
 
 int QUICK_RANGE_SELECT::init_ror_merged_scan(bool reuse_handler)
 {
-  handler *save_file= file, *org_file;
+  Cursor *save_file= file, *org_file;
   Session *session;
 
   in_ror_merged_scan= 1;
@@ -1323,10 +1323,10 @@
     goto end;
   }
 
-  /* Create a separate handler object for this quick select */
+  /* Create a separate Cursor object for this quick select */
   if (free_file)
   {
-    /* already have own 'handler' object. */
+    /* already have own 'Cursor' object. */
     return 0;
   }
 
@@ -1400,7 +1400,7 @@
   SYNOPSIS
     QUICK_ROR_INTERSECT_SELECT::init_ror_merged_scan()
       reuse_handler If true, use head->file, otherwise create separate
-                    handler object.
+                    Cursor object.
   RETURN
     0     OK
     other error code
@@ -1488,7 +1488,7 @@
   quick_selects.delete_elements();
   delete cpk_quick;
   free_root(&alloc,MYF(0));
-  if (need_to_fetch_row && head->file->inited != handler::NONE)
+  if (need_to_fetch_row && head->file->inited != Cursor::NONE)
     head->file->ha_rnd_end();
   return;
 }
@@ -1613,7 +1613,7 @@
     queue->pop();
   delete queue;
   quick_selects.delete_elements();
-  if (head->file->inited != handler::NONE)
+  if (head->file->inited != Cursor::NONE)
     head->file->ha_rnd_end();
   free_root(&alloc,MYF(0));
   return;
@@ -2360,7 +2360,7 @@
         }
 
         /*
-          Simultaneous key scans and row deletes on several handler
+          Simultaneous key scans and row deletes on several Cursor
           objects are not allowed so don't use ROR-intersection for
           table deletes.
         */
@@ -6312,7 +6312,7 @@
 
   RETURN
     Estimate # of records to be retrieved.
-    HA_POS_ERROR if estimate calculation failed due to table handler problems.
+    HA_POS_ERROR if estimate calculation failed due to table Cursor problems.
 */
 
 static
@@ -6322,7 +6322,7 @@
 {
   SEL_ARG_RANGE_SEQ seq;
   RANGE_SEQ_IF seq_if = {sel_arg_range_seq_init, sel_arg_range_seq_next};
-  handler *file= param->table->file;
+  Cursor *file= param->table->file;
   ha_rows rows;
   uint32_t keynr= param->real_keynr[idx];
 
@@ -6873,7 +6873,7 @@
   QUICK_RANGE_SELECT* cur_quick;
   int result;
   Unique *unique;
-  handler *file= head->file;
+  Cursor *file= head->file;
 
   file->extra(HA_EXTRA_KEYREAD);
   head->prepare_for_position();
@@ -6883,7 +6883,7 @@
   assert(cur_quick != 0);
 
   /*
-    We reuse the same instance of handler so we need to call both init and
+    We reuse the same instance of Cursor so we need to call both init and
     reset here.
   */
   if (cur_quick->init() || cur_quick->reset())
@@ -6903,7 +6903,7 @@
       if (!cur_quick)
         break;
 
-      if (cur_quick->file->inited != handler::NONE)
+      if (cur_quick->file->inited != Cursor::NONE)
         cur_quick->file->ha_index_end();
       if (cur_quick->init() || cur_quick->reset())
         return 0;
@@ -7145,7 +7145,7 @@
   last_range= NULL;
   cur_range= (QUICK_RANGE**) ranges.buffer;
 
-  if (file->inited == handler::NONE && (error= file->ha_index_init(index,1)))
+  if (file->inited == Cursor::NONE && (error= file->ha_index_init(index,1)))
     return(error);
 
   /* Allocate buffer if we need one but haven't allocated it yet */
@@ -7163,7 +7163,7 @@
     if (!mrr_buf_desc)
       return(HA_ERR_OUT_OF_MEM);
 
-    /* Initialize the handler buffer. */
+    /* Initialize the Cursor buffer. */
     mrr_buf_desc->buffer= mrange_buff;
     mrr_buf_desc->buffer_end= mrange_buff + buf_size;
     mrr_buf_desc->end_of_used_area= mrange_buff;
@@ -9012,7 +9012,7 @@
 
 QUICK_GROUP_MIN_MAX_SELECT::~QUICK_GROUP_MIN_MAX_SELECT()
 {
-  if (file->inited != handler::NONE)
+  if (file->inited != Cursor::NONE)
     file->ha_index_end();
   if (min_max_arg_part)
     delete_dynamic(&min_max_ranges);

=== modified file 'drizzled/opt_range.h'
--- drizzled/opt_range.h	2009-07-30 02:39:13 +0000
+++ drizzled/opt_range.h	2009-10-16 00:38:56 +0000
@@ -232,8 +232,8 @@
    * intersection scan. The caller must not additionally call init() if this
    * function is called.
    *
-   * @param If true, the quick select may use table->handler,
-   *        otherwise it must create and use a separate handler
+   * @param If true, the quick select may use table->Cursor,
+   *        otherwise it must create and use a separate Cursor
    *        object.
    *
    * @retval
@@ -306,7 +306,7 @@
 class QUICK_RANGE_SELECT : public QUICK_SELECT_I
 {
 protected:
-  handler *file;
+  Cursor *file;
   DYNAMIC_ARRAY ranges; /**< ordered array of range ptrs */
 
   /** Members to deal with case when this quick select is a ROR-merged scan */
@@ -323,7 +323,7 @@
   /** Members needed to use the MRR interface */
   QUICK_RANGE_SEQ_CTX qr_traversal_ctx;
   uint32_t mrr_buf_size; /**< copy from session->variables.read_rnd_buff_size */
-  HANDLER_BUFFER *mrr_buf_desc; /**< the handler buffer */
+  HANDLER_BUFFER *mrr_buf_desc; /**< the Cursor buffer */
 
   /** Info about index we're scanning */
   KEY_PART *key_parts;
@@ -669,7 +669,7 @@
 class QUICK_GROUP_MIN_MAX_SELECT : public QUICK_SELECT_I
 {
 private:
-  handler *file; /**< The handler used to get data. */
+  Cursor *file; /**< The Cursor used to get data. */
   JOIN *join; /**< Descriptor of the current query */
   KEY *index_info; /**< The index chosen for data access */
   unsigned char *record; /**< Buffer where the next record is returned. */

=== modified file 'drizzled/plugin/loader.cc'
--- drizzled/plugin/loader.cc	2009-09-24 21:52:02 +0000
+++ drizzled/plugin/loader.cc	2009-10-16 00:38:56 +0000
@@ -20,7 +20,7 @@
 #include <drizzled/sql_parse.h>
 #include <drizzled/replication_services.h>
 #include <drizzled/show.h>
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <drizzled/set_var.h>
 #include <drizzled/session.h>
 #include <drizzled/item/null.h>

=== modified file 'drizzled/plugin/registry.cc'
--- drizzled/plugin/registry.cc	2009-09-30 22:09:01 +0000
+++ drizzled/plugin/registry.cc	2009-10-16 00:38:56 +0000
@@ -22,7 +22,7 @@
 
 #include "drizzled/plugin.h"
 #include "drizzled/show.h"
-#include "drizzled/handler.h"
+#include "drizzled/cursor.h"
 
 #include <string>
 #include <vector>

=== modified file 'drizzled/plugin/storage_engine.cc'
--- drizzled/plugin/storage_engine.cc	2009-10-15 19:04:03 +0000
+++ drizzled/plugin/storage_engine.cc	2009-10-16 00:38:56 +0000
@@ -33,7 +33,7 @@
 
 #include <drizzled/definitions.h>
 #include <drizzled/base.h>
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <drizzled/plugin/storage_engine.h>
 #include <drizzled/session.h>
 #include <drizzled/error.h>
@@ -127,7 +127,7 @@
   @param name		Base name of table
 
   @note
-    We assume that the handler may return more extensions than
+    We assume that the Cursor may return more extensions than
     was actually used for the file.
 
   @retval
@@ -165,7 +165,7 @@
   if (flags.test(HTON_BIT_FILE_BASED))
     return path;
 
-  /* Ensure that table handler get path in lower case */
+  /* Ensure that table Cursor get path in lower case */
   if (tmp_path != path)
     strcpy(tmp_path, path);
 
@@ -273,7 +273,7 @@
   or the EOF mark to the client. It releases a possible adaptive hash index
   S-latch held by session in InnoDB and also releases a possible InnoDB query
   FIFO ticket to enter InnoDB. To save CPU time, InnoDB allows a session to
-  keep them over several calls of the InnoDB handler interface when a join
+  keep them over several calls of the InnoDB Cursor interface when a join
   is executed. But when we let the control to pass to the client they have
   to be released because if the application program uses mysql_use_result(),
   it may deadlock on the S-latch if the application on another connection
@@ -516,7 +516,7 @@
 }
 
 /**
-  Call this function in order to give the handler the possiblity
+  Call this function in order to give the Cursor the possiblity
   to ask engine if there are any new tables that should be written to disk
   or any dropped tables that need to be removed from disk
 */
@@ -590,17 +590,17 @@
 {
   Session *session;
   const char *path;
-  handler **file;
+  Cursor **file;
   int *dt_error;
 public:
   DeleteTableStorageEngine(Session *session_arg, const char *path_arg,
-                           handler **file_arg, int *error_arg)
+                           Cursor **file_arg, int *error_arg)
     : session(session_arg), path(path_arg), file(file_arg), dt_error(error_arg) {}
 
   result_type operator() (argument_type engine)
   {
     char tmp_path[FN_REFLEN];
-    handler *tmp_file;
+    Cursor *tmp_file;
 
     if(*dt_error!=ENOENT) /* already deleted table */
       return;
@@ -660,7 +660,7 @@
   dummy_table.s= &dummy_share;
 
   int error= ENOENT;
-  handler *file= NULL;
+  Cursor *file= NULL;
 
   for_each(all_engines.begin(), all_engines.end(),
            DeleteTableStorageEngine(session, path, &file, &error));
@@ -672,7 +672,7 @@
   {
     /*
       Because file->print_error() use my_error() to generate the error message
-      we use an internal error handler to intercept it and store the text
+      we use an internal error Cursor to intercept it and store the text
       in a temporary buffer. Later the message will be presented to user
       as a warning.
     */
@@ -905,9 +905,9 @@
   return(error != 0);
 }
 
-handler *plugin::StorageEngine::getCursor(TableShare *share, MEM_ROOT *alloc)
+Cursor *plugin::StorageEngine::getCursor(TableShare *share, MEM_ROOT *alloc)
 {
-  handler *file;
+  Cursor *file;
 
   assert(enabled);
 

=== modified file 'drizzled/plugin/storage_engine.h'
--- drizzled/plugin/storage_engine.h	2009-10-15 19:04:03 +0000
+++ drizzled/plugin/storage_engine.h	2009-10-16 00:38:56 +0000
@@ -35,7 +35,7 @@
 class TableList;
 class Session;
 class XID;
-class handler;
+class Cursor;
 
 class TableShare;
 typedef struct st_mysql_lex_string LEX_STRING;
@@ -81,7 +81,7 @@
 /*
   StorageEngine is a singleton structure - one instance per storage engine -
   to provide access to storage engine functionality that works on the
-  "global" level (unlike handler class that works on a per-table basis)
+  "global" level (unlike Cursor class that works on a per-table basis)
 
   usually StorageEngine instance is defined statically in ha_xxx.cc as
 
@@ -97,7 +97,7 @@
   const bool two_phase_commit;
   bool enabled;
 
-  const std::bitset<HTON_BIT_SIZE> flags; /* global handler flags */
+  const std::bitset<HTON_BIT_SIZE> flags; /* global Cursor flags */
   /*
     to store per-savepoint data storage engine is provided with an area
     of a requested size (0 is ok here).
@@ -237,7 +237,7 @@
   virtual int  recover(XID *, uint32_t) { return 0; }
   virtual int  commit_by_xid(XID *) { return 0; }
   virtual int  rollback_by_xid(XID *) { return 0; }
-  virtual handler *create(TableShare *, MEM_ROOT *)= 0;
+  virtual Cursor *create(TableShare *, MEM_ROOT *)= 0;
   /* args: path */
   virtual void drop_database(char*) { }
   virtual int start_consistent_snapshot(Session *) { return 0; }
@@ -255,7 +255,7 @@
   /**
     If frm_error() is called then we will use this to find out what file
     extentions exist for the storage engine. This is also used by the default
-    rename_table and delete_table method in handler.cc.
+    rename_table and delete_table method in Cursor.cc.
 
     For engines that have two file name extentions (separate meta/index file
     and data file), the order of elements is relevant. First element of engine
@@ -346,7 +346,7 @@
                          bool update_create_info,
                          drizzled::message::Table *table_proto);
 
-  handler *getCursor(TableShare *share, MEM_ROOT *alloc);
+  Cursor *getCursor(TableShare *share, MEM_ROOT *alloc);
 };
 
 class TableNameIteratorImplementation

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2009-10-15 19:04:03 +0000
+++ drizzled/session.h	2009-10-16 00:38:56 +0000
@@ -28,7 +28,7 @@
 #include <drizzled/ha_trx_info.h>
 #include <mysys/my_alloc.h>
 #include <mysys/my_tree.h>
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <drizzled/current_session.h>
 #include <drizzled/sql_error.h>
 #include <drizzled/file_exchange.h>

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-10-08 13:21:06 +0000
+++ drizzled/show.cc	2009-10-16 00:38:56 +0000
@@ -116,7 +116,7 @@
  * @brief
  *   Find subdirectories (schemas) in a given directory (datadir).
  *
- * @param[in]  session    Thread handler
+ * @param[in]  session    Thread Cursor
  * @param[out] files      Put found entries in this list
  * @param[in]  path       Path to database
  * @param[in]  wild       Filter for found entries
@@ -442,7 +442,7 @@
   uint32_t primary_key;
   KEY *key_info;
   Table *table= table_list->table;
-  handler *file= table->file;
+  Cursor *file= table->file;
   TableShare *share= table->s;
   HA_CREATE_INFO create_info;
   bool show_table_options= false;
@@ -1022,7 +1022,7 @@
 
   SYNOPSIS
     schema_table_store_record()
-    session                   thread handler
+    session                   thread Cursor
     table                 Information schema table to be updated
 
   RETURN
@@ -1065,7 +1065,7 @@
            fill appropriate lookup_field_vals struct field
            with this value.
 
-  @param[in]      session                   thread handler
+  @param[in]      session                   thread Cursor
   @param[in]      item_func             part of WHERE condition
   @param[in]      table                 I_S table
   @param[in, out] lookup_field_vals     Struct which holds lookup values
@@ -1147,7 +1147,7 @@
            from 'WHERE' condition if it's possible and
            fill lookup_field_vals struct fields with these values.
 
-  @param[in]      session                   thread handler
+  @param[in]      session                   thread Cursor
   @param[in]      cond                  WHERE condition
   @param[in]      table                 I_S table
   @param[in, out] lookup_field_vals     Struct which holds lookup values
@@ -1295,7 +1295,7 @@
            from LEX struct and fill lookup_field_vals struct field
            with these values.
 
-  @param[in]      session                   thread handler
+  @param[in]      session                   thread Cursor
   @param[in]      cond                  WHERE condition
   @param[in]      tables                I_S table
   @param[in, out] lookup_field_values   Struct which holds lookup values
@@ -1357,7 +1357,7 @@
  * @brief
  *   Create db names list. Information schema name always is first in list
  *
- * @param[in]  session          Thread handler
+ * @param[in]  session          Thread Cursor
  * @param[out] files            List of db names
  * @param[in]  wild             Wild string
  * @param[in]  idx_field_vals   idx_field_vals->db_name contains db name or
@@ -1446,7 +1446,7 @@
   @details        The function creates the list of table names in
                   database
 
-  @param[in]      session                   thread handler
+  @param[in]      session                   thread Cursor
   @param[in]      table_names           List of table names in database
   @param[in]      lex                   pointer to LEX struct
   @param[in]      lookup_field_vals     pointer to LOOKUP_FIELD_VALUE struct
@@ -1531,7 +1531,7 @@
 /**
   @brief          Fill I_S table for SHOW COLUMNS|INDEX commands
 
-  @param[in]      session                      thread handler
+  @param[in]      session                      thread Cursor
   @param[in]      tables                   TableList for I_S table
   @param[in]      schema_table             pointer to I_S structure
   @param[in]      open_tables_state_backup pointer to Open_tables_state object
@@ -1606,7 +1606,7 @@
 /**
   @brief          Fill I_S table for SHOW Table NAMES commands
 
-  @param[in]      session                      thread handler
+  @param[in]      session                      thread Cursor
   @param[in]      table                    Table struct for I_S table
   @param[in]      db_name                  database name
   @param[in]      table_name               table name
@@ -1688,7 +1688,7 @@
 /**
   @brief          Fill I_S table with data from FRM file only
 
-  @param[in]      session                      thread handler
+  @param[in]      session                      thread Cursor
   @param[in]      table                    Table struct for I_S table
   @param[in]      schema_table             I_S table struct
   @param[in]      db_name                  database name
@@ -1758,7 +1758,7 @@
                   from frm files and storage engine are filled by the function
                   plugin::InfoSchemaMethods::fillTable().
 
-  @param[in]      session                      thread handler
+  @param[in]      session                      thread Cursor
   @param[in]      tables                   I_S table
   @param[in]      cond                     'WHERE' condition
 
@@ -2319,7 +2319,7 @@
 
   SYNOPSIS
     plugin::InfoSchemaMethods::oldFormat()
-    session			thread handler
+    session			thread Cursor
     schema_table        pointer to 'schema_tables' element
 
   RETURN
@@ -2362,7 +2362,7 @@
 
   SYNOPSIS
   mysql_schema_table()
-    session                thread handler
+    session                thread Cursor
     lex                pointer to LEX
     table_list         pointer to table_list
 
@@ -2403,7 +2403,7 @@
 
   SYNOPSIS
     make_schema_select()
-    session                  thread handler
+    session                  thread Cursor
     sel                  pointer to Select_Lex
     schema_table_name    name of 'schema_tables' element
 

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-10-12 05:13:54 +0000
+++ drizzled/sql_base.cc	2009-10-16 00:38:56 +0000
@@ -111,7 +111,7 @@
 
   SYNOPSIS
   close_handle_and_leave_table_as_lock()
-  table		Table handler
+  table		Table Cursor
 
   NOTES
   By leaving the table in the table cache, it disallows any other thread
@@ -464,7 +464,7 @@
 
   safe_mutex_assert_owner(&LOCK_open);
   assert(table->key_read == 0);
-  assert(!table->file || table->file->inited == handler::NONE);
+  assert(!table->file || table->file->inited == Cursor::NONE);
 
   open_tables= table->next;
 
@@ -829,7 +829,7 @@
 
   SYNOPSIS
   wait_for_condition()
-  session	Thread handler
+  session	Thread Cursor
   mutex	mutex that is currently hold that is associated with condition
   Will be unlocked on return
   cond	Condition to wait for
@@ -1437,7 +1437,7 @@
 
 #ifdef EXTRA_DEBUG
   if (table->db_stat)
-    errmsg_printf(ERRMSG_LVL_ERROR, _("Table %s had a open data handler in reopen_table"),
+    errmsg_printf(ERRMSG_LVL_ERROR, _("Table %s had a open data Cursor in reopen_table"),
                   table->alias);
 #endif
   table_list.db=         table->s->db.str;
@@ -2084,7 +2084,7 @@
 
   SYNOPSIS
   open_tables()
-  session - thread handler
+  session - thread Cursor
   start - list of tables in/out
   counter - number of opened tables will be return using this parameter
   flags   - bitmap of flags to modify how the tables will be open:
@@ -2216,7 +2216,7 @@
 
   SYNOPSIS
   openTableLock()
-  session			Thread handler
+  session			Thread Cursor
   table_list		Table to open is first table in this list
   lock_type		Lock to use for open
   lock_flags          Flags passed to mysql_lock_table
@@ -2267,7 +2267,7 @@
 
   SYNOPSIS
   lock_tables()
-  session			Thread handler
+  session			Thread Cursor
   tables		Tables to lock
   count		Number of opened tables
   need_reopen         Out parameter which if true indicates that some
@@ -2475,7 +2475,7 @@
 
   SYNOPSIS
   find_field_in_natural_join()
-  session			 [in]  thread handler
+  session			 [in]  thread Cursor
   table_ref            [in]  table reference to search
   name		 [in]  name of field
   length		 [in]  length of name
@@ -2544,7 +2544,7 @@
 
   SYNOPSIS
   find_field_in_table()
-  session				thread handler
+  session				thread Cursor
   table			table where to search for the field
   name			name of field
   length			length of name
@@ -2616,7 +2616,7 @@
 
   SYNOPSIS
   find_field_in_table_ref()
-  session			   [in]  thread handler
+  session			   [in]  thread Cursor
   table_list		   [in]  table reference to search
   name		   [in]  name of field
   length		   [in]  field length of name
@@ -2747,7 +2747,7 @@
     if (session->mark_used_columns != MARK_COLUMNS_NONE)
     {
       /*
-        Get rw_set correct for this field so that the handler
+        Get rw_set correct for this field so that the Cursor
         knows that this field is involved in the query and gets
         retrieved/updated
       */
@@ -3987,7 +3987,7 @@
 
   SYNOPSIS
   setup_tables()
-  session		  Thread handler
+  session		  Thread Cursor
   context       name resolution contest to setup table list there
   from_clause   Top-level list of table references in the FROM clause
   tables	  Table list (select_lex->table_list)
@@ -4064,7 +4064,7 @@
 
   SYNOPSIS
   setup_tables_and_check_view_access()
-  session		  Thread handler
+  session		  Thread Cursor
   context       name resolution contest to setup table list there
   from_clause   Top-level list of table references in the FROM clause
   tables	  Table list (select_lex->table_list)
@@ -4107,7 +4107,7 @@
 
   SYNOPSIS
   insert_fields()
-  session			Thread handler
+  session			Thread Cursor
   context             Context for name resolution
   db_name		Database name in case of 'database_name.table_name.*'
   table_name		Table name in case of 'table_name.*'
@@ -4259,7 +4259,7 @@
 
   SYNOPSIS
   setup_conds()
-  session     thread handler
+  session     thread Cursor
   tables  list of tables for name resolving (select_lex->table_list)
   leaves  list of leaves of join table tree (select_lex->leaf_tables)
   conds   WHERE clause
@@ -4354,7 +4354,7 @@
 
   SYNOPSIS
   fill_record()
-  session           thread handler
+  session           thread Cursor
   fields        Item_fields list to be filled
   values        values to fill with
   ignore_errors true if we should ignore errors
@@ -4450,7 +4450,7 @@
 
   SYNOPSIS
   fill_record()
-  session           thread handler
+  session           thread Cursor
   ptr           pointer on pointer to record
   values        list of fields
   ignore_errors true if we should ignore errors

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-09-29 22:28:50 +0000
+++ drizzled/sql_select.cc	2009-10-16 00:38:56 +0000
@@ -315,7 +315,7 @@
 /**
   An entry point to single-unit select (a select without UNION).
 
-  @param session                  thread handler
+  @param session                  thread Cursor
   @param rref_pointer_array   a reference to ref_pointer_array of
                               the top-level select_lex for this query
   @param tables               list of all tables used in this query.
@@ -2227,7 +2227,7 @@
     can get more freedom in performing join operations.
     Althogh we don't use this property now, it probably makes sense to use
     it in the future.
-  @param session		      Thread handler
+  @param session		      Thread Cursor
   @param cond                condition to build the multiple equalities for
   @param inherited           path to all inherited multiple equality items
   @param join_list           list of join tables to which the condition
@@ -5201,7 +5201,7 @@
 
   SYNOPSIS
    create_sort_index()
-     session		Thread handler
+     session		Thread Cursor
      tab		Table to sort (in join structure)
      order		How table should be sorted
      filesort_limit	Max number of rows that needs to be sorted
@@ -5326,7 +5326,7 @@
 
 int remove_dup_with_compare(Session *session, Table *table, Field **first_field, uint32_t offset, Item *having)
 {
-  handler *file=table->file;
+  Cursor *file=table->file;
   char *org_record,*new_record;
   unsigned char *record;
   int error;
@@ -5421,7 +5421,7 @@
 {
   unsigned char *key_buffer, *key_pos, *record=table->record[0];
   int error;
-  handler *file= table->file;
+  Cursor *file= table->file;
   uint32_t extra_length= ALIGN_SIZE(key_length)-key_length;
   uint32_t *field_lengths,*field_length;
   HASH hash;
@@ -5802,7 +5802,7 @@
 /**
   Intitialize the GROUP BY list.
 
-  @param session			Thread handler
+  @param session			Thread Cursor
   @param ref_pointer_array	We store references to all fields that was
                                not in 'fields' here.
   @param fields		All fields in the select part. Any item in
@@ -6372,7 +6372,7 @@
 /**
   Call ::setup for all sum functions.
 
-  @param session           thread handler
+  @param session           thread Cursor
   @param func_ptr      sum function list
 
   @retval
@@ -7088,7 +7088,7 @@
 
 /**
   Print joins from the FROM clause.
-  @param session     thread handler
+  @param session     thread Cursor
   @param str     string where table should be printed
   @param tables  list of tables in join
   @query_type    type of the query is being generated

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-10-15 19:04:03 +0000
+++ drizzled/sql_table.cc	2009-10-16 00:38:56 +0000
@@ -420,13 +420,13 @@
 
   SYNOPSIS
     mysql_rm_table_part2()
-    session			Thread handler
+    session			Thread Cursor
     tables		Tables to drop
     if_exists		If set, don't give an error if table doesn't exists.
 			In this case we give an warning of level 'NOTE'
     drop_temporary	Only drop temporary tables
     dont_log_query	Don't write query to log files. This will also not
-			generate warnings if the handler files doesn't exists
+			generate warnings if the Cursor files doesn't exists
 
   TODO:
     When logging to the binary log, we should log
@@ -831,7 +831,7 @@
                                AlterInfo *alter_info,
                                bool tmp_table,
                                uint32_t *db_options,
-                               handler *file,
+                               Cursor *file,
                                KEY **key_info_buffer,
                                uint32_t *key_count,
                                int select_field_count)
@@ -1597,7 +1597,7 @@
   uint32_t          path_length;
   uint		db_options, key_count;
   KEY		*key_info_buffer;
-  handler	*file;
+  Cursor	*file;
   bool		error= true;
   /* Check for duplicate fields and check type of table to create */
   if (!alter_info->create_list.elements)
@@ -1614,7 +1614,7 @@
     db_options|=HA_OPTION_PACK_RECORD;
   if (!(file= create_info->db_type->getCursor((TableShare*) 0, session->mem_root)))
   {
-    my_error(ER_OUTOFMEMORY, MYF(0), sizeof(handler));
+    my_error(ER_OUTOFMEMORY, MYF(0), sizeof(Cursor));
     return true;
   }
 
@@ -1946,7 +1946,7 @@
 
   SYNOPSIS
     wait_while_table_is_used()
-    session			Thread handler
+    session			Thread Cursor
     table		Table to remove from cache
     function            HA_EXTRA_PREPARE_FOR_DROP if table is to be deleted
                         HA_EXTRA_FORCE_REOPEN if table is not be used
@@ -1981,7 +1981,7 @@
 
   SYNOPSIS
     close_cached_table()
-    session			Thread handler
+    session			Thread Cursor
     table		Table to remove from cache
 
   NOTES
@@ -2025,7 +2025,7 @@
                               uint32_t extra_open_options,
                               int (*prepare_func)(Session *, TableList *,
                                                   HA_CHECK_OPT *),
-                              int (handler::*operator_func)(Session *,
+                              int (Cursor::*operator_func)(Session *,
                                                             HA_CHECK_OPT *))
 {
   TableList *table;
@@ -2155,7 +2155,7 @@
       open_for_modify= 0;
     }
 
-    if (table->table->s->crashed && operator_func == &handler::ha_check)
+    if (table->table->s->crashed && operator_func == &Cursor::ha_check)
     {
       session->client->store(table_name);
       session->client->store(operator_name);
@@ -2350,7 +2350,7 @@
 {
   return(mysql_admin_table(session, tables, check_opt,
                            "optimize", TL_WRITE, 1,0,0,0,
-                           &handler::ha_optimize));
+                           &Cursor::ha_optimize));
 }
 
 /*
@@ -2597,7 +2597,7 @@
 
   return(mysql_admin_table(session, tables, check_opt,
 				"analyze", lock_type, 1, 0, 0, 0,
-				&handler::ha_analyze));
+				&Cursor::ha_analyze));
 }
 
 
@@ -2608,7 +2608,7 @@
   return(mysql_admin_table(session, tables, check_opt,
 				"check", lock_type,
 				0, 0, HA_OPEN_FOR_REPAIR, 0,
-				&handler::ha_check));
+				&Cursor::ha_check));
 }
 
 /*
@@ -2616,7 +2616,7 @@
 
   SYNOPSIS
     mysql_recreate_table()
-    session			Thread handler
+    session			Thread Cursor
     tables		Tables to recreate
 
  RETURN

=== modified file 'drizzled/sql_table.h'
--- drizzled/sql_table.h	2009-10-07 21:45:49 +0000
+++ drizzled/sql_table.h	2009-10-16 00:38:56 +0000
@@ -76,7 +76,7 @@
       alter_info                List of columns and indexes to create
       tmp_table                 If a temporary table is to be created.
       db_options          INOUT Table options (like HA_OPTION_PACK_RECORD).
-      file                      The handler for the new table.
+      file                      The Cursor for the new table.
       key_info_buffer     OUT   An array of KEY structs for the indexes.
       key_count           OUT   The number of elements in the array.
       select_field_count        The number of fields coming from a select table.
@@ -96,7 +96,7 @@
                                AlterInfo *alter_info,
                                bool tmp_table,
                                uint32_t *db_options,
-                               handler *file,
+                               Cursor *file,
                                KEY **key_info_buffer,
                                uint32_t *key_count,
                                int select_field_count);

=== modified file 'drizzled/structs.h'
--- drizzled/structs.h	2009-07-21 17:13:11 +0000
+++ drizzled/structs.h	2009-10-16 00:38:56 +0000
@@ -119,11 +119,11 @@
 struct st_read_record;				/* For referense later */
 class SQL_SELECT;
 class Session;
-class handler;
+class Cursor;
 
 typedef struct st_read_record {			/* Parameter to read_record */
   Table *table;			/* Head-form */
-  handler *file;
+  Cursor *file;
   Table **forms;			/* head and ref forms */
   int (*read_record)(struct st_read_record *);
   Session *session;

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-10-15 19:04:03 +0000
+++ drizzled/table.cc	2009-10-16 00:38:56 +0000
@@ -277,7 +277,7 @@
                       TableShare *share)
 {
   int error= 0;
-  handler *handler_file= NULL;
+  Cursor *handler_file= NULL;
 
   share->setTableProto(new(nothrow) message::Table(table));
 
@@ -850,7 +850,7 @@
     memset(&temp_table, 0, sizeof(temp_table));
     temp_table.s= share;
     temp_table.in_use= session;
-    temp_table.s->db_low_byte_first= 1; //handler->low_byte_first();
+    temp_table.s->db_low_byte_first= 1; //Cursor->low_byte_first();
     temp_table.s->blob_ptr_size= portable_sizeof_char_ptr;
 
     Field* f= make_field(share,
@@ -1175,7 +1175,7 @@
 
   SYNOPSIS
   open_table_def()
-  session		Thread handler
+  session		Thread Cursor
   share		Fill this with table definition
 
   NOTES
@@ -1247,7 +1247,7 @@
 
   SYNOPSIS
     open_table_from_share()
-    session			Thread handler
+    session			Thread Cursor
     share		Table definition
     alias       	Alias for table
     db_stat		open flags (for example HA_OPEN_KEYFILE|
@@ -1290,7 +1290,7 @@
   if (!(outparam->alias= strdup(alias)))
     goto err;
 
-  /* Allocate handler */
+  /* Allocate Cursor */
   if (!(prgflag & OPEN_FRM_FILE_ONLY))
   {
     if (!(outparam->file= share->db_type()->getCursor(share, &outparam->mem_root)))
@@ -1562,7 +1562,7 @@
     break;
   case 2:
   {
-    handler *file= 0;
+    Cursor *file= 0;
     const char *datext= "";
 
     if (db_type() != NULL)
@@ -1902,7 +1902,7 @@
 
 
 /*
-  Tell handler we are going to call position() and rnd_pos() later.
+  Tell Cursor we are going to call position() and rnd_pos() later.
 
   NOTES:
   This is needed for handlers that uses the primary key to find the
@@ -2028,7 +2028,7 @@
 void Table::mark_columns_needed_for_delete()
 {
   /*
-    If the handler has no cursor capabilites, or we have row-based
+    If the Cursor has no cursor capabilites, or we have row-based
     replication active for the current statement, we have to read
     either the primary key, the hidden primary key or all columns to
     be able to do an delete
@@ -2077,7 +2077,7 @@
 void Table::mark_columns_needed_for_update()
 {
   /*
-    If the handler has no cursor capabilites, or we have row-based
+    If the Cursor has no cursor capabilites, or we have row-based
     logging active for the current statement, we have to read either
     the primary key, the hidden primary key or all columns to be
     able to do an update
@@ -2107,7 +2107,7 @@
 
 
 /*
-  Mark columns the handler needs for doing an insert
+  Mark columns the Cursor needs for doing an insert
 
   For now, this is used to mark fields used by the trigger
   as changed.
@@ -2148,7 +2148,7 @@
 /**
   Create field for temporary table from given field.
 
-  @param session	       Thread handler
+  @param session	       Thread Cursor
   @param org_field    field from which new field will be created
   @param name         New field name
   @param table	       Temporary table
@@ -2209,7 +2209,7 @@
 /**
   Create field for information schema table.
 
-  @param session		Thread handler
+  @param session		Thread Cursor
   @param table		Temporary table
   @param item		Item to create a field for
 
@@ -2934,7 +2934,7 @@
   Create a reduced Table object with properly set up Field list from a
   list of field definitions.
 
-    The created table doesn't have a table handler associated with
+    The created table doesn't have a table Cursor associated with
     it, has no keys, no group/distinct, no copy_funcs array.
     The sole purpose of this Table object is to use the power of Field
     class to read/write data to/from table->record[0]. Then one can store
@@ -3481,7 +3481,7 @@
   Returns -1 if row was not found, 0 if row was found and 1 on errors
 *****************************************************************************/
 
-/** Help function when we get some an error from the table handler. */
+/** Help function when we get some an error from the table Cursor. */
 
 int Table::report_error(int error)
 {

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-09-16 20:04:11 +0000
+++ drizzled/table.h	2009-10-16 00:38:56 +0000
@@ -30,7 +30,7 @@
 #include "drizzled/filesort_info.h"
 #include "drizzled/natural_join_column.h"
 #include "drizzled/field_iterator.h"
-#include "drizzled/handler.h"
+#include "drizzled/cursor.h"
 #include "drizzled/lex_string.h"
 #include "drizzled/table_list.h"
 #include "drizzled/table_share.h"
@@ -67,7 +67,7 @@
   TableShare *s; /**< Pointer to the shared metadata about the table */
   Field **field; /**< Pointer to fields collection */
 
-  handler *file; /**< Pointer to the storage engine's handler managing this table */
+  Cursor *file; /**< Pointer to the storage engine's Cursor managing this table */
   Table *next;
   Table *prev;
 
@@ -75,7 +75,7 @@
   MyBitmap *write_set; /* Active column sets */
 
   uint32_t tablenr;
-  uint32_t db_stat; /**< information about the file as in handler.h */
+  uint32_t db_stat; /**< information about the file as in Cursor.h */
 
   MyBitmap def_read_set; /**< Default read set of columns */
   MyBitmap def_write_set; /**< Default write set of columns */
@@ -135,7 +135,7 @@
     - setting version to 0 - this will force other threads to close
       the instance of this table and wait (this is the same approach
       as used for usual name locks).
-    An exclusively name-locked table currently can have no handler
+    An exclusively name-locked table currently can have no Cursor
     object associated with it (db_stat is always 0), but please do
     not rely on that.
   */

=== modified file 'plugin/archive/ha_archive.cc'
--- plugin/archive/ha_archive.cc	2009-10-07 18:30:38 +0000
+++ plugin/archive/ha_archive.cc	2009-10-16 00:38:56 +0000
@@ -222,7 +222,7 @@
                                      HTON_FILE_BASED
                                       | HTON_HAS_DATA_DICTIONARY) {}
 
-  virtual handler *create(TableShare *table,
+  virtual Cursor *create(TableShare *table,
                           MEM_ROOT *mem_root)
   {
     return new (mem_root) ha_archive(this, table);
@@ -289,7 +289,7 @@
 static ArchiveEngine *archive_engine= NULL;
 
 /*
-  Initialize the archive handler.
+  Initialize the archive Cursor.
 
   SYNOPSIS
     archive_db_init()
@@ -314,7 +314,7 @@
 }
 
 /*
-  Release the archive handler.
+  Release the archive Cursor.
 
   SYNOPSIS
     archive_db_done()
@@ -337,7 +337,7 @@
 
 ha_archive::ha_archive(drizzled::plugin::StorageEngine *engine_arg,
                        TableShare *table_arg)
-  :handler(engine_arg, table_arg), delayed_insert(0), bulk_insert(0)
+  :Cursor(engine_arg, table_arg), delayed_insert(0), bulk_insert(0)
 {
   /* Set our original buffer from pre-allocated memory */
   buffer.set((char *)byte_buffer, IO_SIZE, system_charset_info);
@@ -516,7 +516,7 @@
 
 
 /*
-  No locks are required because it is associated with just one handler instance
+  No locks are required because it is associated with just one Cursor instance
 */
 int ha_archive::init_archive_reader()
 {

=== modified file 'plugin/archive/ha_archive.h'
--- plugin/archive/ha_archive.h	2009-09-23 19:20:45 +0000
+++ plugin/archive/ha_archive.h	2009-10-16 00:38:56 +0000
@@ -19,7 +19,7 @@
 #include "azio.h"
 #include <mysys/thr_lock.h>
 #include <mysys/hash.h>
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <string>
 
 /*
@@ -66,7 +66,7 @@
 */
 #define ARCHIVE_VERSION 3
 
-class ha_archive: public handler
+class ha_archive: public Cursor
 {
   THR_LOCK_DATA lock;        /* MySQL lock */
   ArchiveShare *share;      /* Shared lock info */

=== modified file 'plugin/blackhole/ha_blackhole.cc'
--- plugin/blackhole/ha_blackhole.cc	2009-09-25 19:52:07 +0000
+++ plugin/blackhole/ha_blackhole.cc	2009-10-16 00:38:56 +0000
@@ -33,7 +33,7 @@
 public:
   BlackholeEngine(const string &name_arg)
    : drizzled::plugin::StorageEngine(name_arg, HTON_FILE_BASED | HTON_CAN_RECREATE) {}
-  virtual handler *create(TableShare *table,
+  virtual Cursor *create(TableShare *table,
                           MEM_ROOT *mem_root)
   {
     return new (mem_root) ha_blackhole(this, table);
@@ -63,7 +63,7 @@
 
 ha_blackhole::ha_blackhole(drizzled::plugin::StorageEngine *engine_arg,
                            TableShare *table_arg)
-  :handler(engine_arg, table_arg)
+  :Cursor(engine_arg, table_arg)
 {}
 
 uint32_t ha_blackhole::index_flags(uint32_t inx, uint32_t, bool) const

=== modified file 'plugin/blackhole/ha_blackhole.h'
--- plugin/blackhole/ha_blackhole.h	2009-09-23 19:20:45 +0000
+++ plugin/blackhole/ha_blackhole.h	2009-10-16 00:38:56 +0000
@@ -17,7 +17,7 @@
 #ifndef STORAGE_BLACKHOLE_HA_BLACKHOLE_H
 #define STORAGE_BLACKHOLE_HA_BLACKHOLE_H
 
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <mysys/thr_lock.h>
 
 #define BLACKHOLE_MAX_KEY	64		/* Max allowed keys */
@@ -39,7 +39,7 @@
   Class definition for the blackhole storage engine
   "Dumbest named feature ever"
 */
-class ha_blackhole: public handler
+class ha_blackhole: public Cursor
 {
   THR_LOCK_DATA lock;      /* MySQL lock */
   st_blackhole_share *share;

=== modified file 'plugin/csv/ha_tina.cc'
--- plugin/csv/ha_tina.cc	2009-09-25 19:52:07 +0000
+++ plugin/csv/ha_tina.cc	2009-10-16 00:38:56 +0000
@@ -108,7 +108,7 @@
 
 /*
   If frm_error() is called in table.cc this is called to find out what file
-  extensions exist for this handler.
+  extensions exist for this Cursor.
 */
 static const char *ha_tina_exts[] = {
   CSV_EXT,
@@ -121,7 +121,7 @@
 public:
   Tina(const string& name_arg)
    : drizzled::plugin::StorageEngine(name_arg, HTON_CAN_RECREATE | HTON_TEMPORARY_ONLY | HTON_FILE_BASED) {}
-  virtual handler *create(TableShare *table,
+  virtual Cursor *create(TableShare *table,
                           MEM_ROOT *mem_root)
   {
     return new (mem_root) ha_tina(this, table);
@@ -455,9 +455,9 @@
 
 
 ha_tina::ha_tina(drizzled::plugin::StorageEngine *engine_arg, TableShare *table_arg)
-  :handler(engine_arg, table_arg),
+  :Cursor(engine_arg, table_arg),
   /*
-    These definitions are found in handler.h
+    These definitions are found in Cursor.h
     They are not probably completely right.
   */
   current_position(0), next_position(0), local_saved_data_file_length(0),
@@ -817,7 +817,7 @@
     return(0);
 
   /*
-    Init locking. Pass handler object to the locking routines,
+    Init locking. Pass Cursor object to the locking routines,
     so that they could save/update local_saved_data_file_length value
     during locking. This is needed to enable concurrent inserts.
   */
@@ -844,7 +844,7 @@
 }
 
 /*
-  This is an INSERT. At the moment this handler just seeks to the end
+  This is an INSERT. At the moment this Cursor just seeks to the end
   of the file and appends the data. In an error case it really should
   just truncate to the original position (this is not done yet).
 */
@@ -904,7 +904,7 @@
   This is called for an update.
   Make sure you put in code to increment the auto increment, also
   update any timestamp data. Currently auto increment is not being
-  fixed since autoincrements have yet to be added to this table handler.
+  fixed since autoincrements have yet to be added to this table Cursor.
   This will be called in a table scan right before the previous ::rnd_next()
   call.
 */
@@ -948,7 +948,7 @@
   Deletes a row. First the database will find the row, and then call this
   method. In the case of a table scan, the previous call to this will be
   the ::rnd_next() that found this row.
-  The exception to this is an ORDER BY. This will cause the table handler
+  The exception to this is an ORDER BY. This will cause the table Cursor
   to walk the table noting the positions of all rows that match a query.
   The table will then be deleted/positioned based on the ORDER (so RANDOM,
   DESC, ASC).
@@ -1055,8 +1055,8 @@
   reserved for null count.
   Basically this works as a mask for which rows are nulled (compared to just
   empty).
-  This table handler doesn't do nulls and does not know the difference between
-  NULL and "". This is ok since this table handler is for spreadsheets and
+  This table Cursor doesn't do nulls and does not know the difference between
+  NULL and "". This is ok since this table Cursor is for spreadsheets and
   they don't know about them either :)
 */
 int ha_tina::rnd_next(unsigned char *buf)
@@ -1111,7 +1111,7 @@
 
 /*
   ::info() is used to return information to the optimizer.
-  Currently this table handler doesn't implement most of the fields
+  Currently this table Cursor doesn't implement most of the fields
   really needed. SHOW also makes use of this data
 */
 int ha_tina::info(uint32_t)

=== modified file 'plugin/csv/ha_tina.h'
--- plugin/csv/ha_tina.h	2009-09-23 19:20:45 +0000
+++ plugin/csv/ha_tina.h	2009-10-16 00:38:56 +0000
@@ -16,7 +16,7 @@
 #ifndef STORAGE_CSV_HA_TINA_H
 #define STORAGE_CSV_HA_TINA_H
 
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <mysys/thr_lock.h>
 
 #include <sys/types.h>
@@ -46,7 +46,7 @@
   bool update_file_opened;
   bool tina_write_opened;
   File meta_file;           /* Meta file we use */
-  File tina_write_filedes;  /* File handler for readers */
+  File tina_write_filedes;  /* File Cursor for readers */
   bool crashed;             /* Meta file is crashed */
   ha_rows rows_recorded;    /* Number of rows in tables */
   uint32_t data_file_version;   /* Version of the data file used */
@@ -57,7 +57,7 @@
   off_t end;
 };
 
-class ha_tina: public handler
+class ha_tina: public Cursor
 {
   THR_LOCK_DATA lock;      /* MySQL lock */
   TINA_SHARE *share;       /* Shared lock info */
@@ -67,7 +67,7 @@
   off_t temp_file_length;
   unsigned char byte_buffer[IO_SIZE];
   Transparent_file *file_buff;
-  File data_file;                   /* File handler for readers */
+  File data_file;                   /* File Cursor for readers */
   File update_temp_file;
   String buffer;
   /*
@@ -154,7 +154,7 @@
       enum thr_lock_type lock_type);
 
   /*
-    These functions used to get/update status of the handler.
+    These functions used to get/update status of the Cursor.
     Needed to enable concurrent inserts.
   */
   void get_status();

=== modified file 'plugin/heap/ha_heap.cc'
--- plugin/heap/ha_heap.cc	2009-10-15 19:04:03 +0000
+++ plugin/heap/ha_heap.cc	2009-10-16 00:38:56 +0000
@@ -47,7 +47,7 @@
     addAlias("HEAP");
   }
 
-  virtual handler *create(TableShare *table,
+  virtual Cursor *create(TableShare *table,
                           MEM_ROOT *mem_root)
   {
     return new (mem_root) ha_heap(this, table);
@@ -61,7 +61,7 @@
                                 Table *table_arg, HA_CREATE_INFO *create_info,
                                 drizzled::message::Table*);
 
-  /* For whatever reason, internal tables can be created by handler::open()
+  /* For whatever reason, internal tables can be created by Cursor::open()
      for HEAP.
      Instead of diving down a rat hole, let's just cry ourselves to sleep
      at night with this odd hackish workaround.
@@ -115,7 +115,7 @@
 
 ha_heap::ha_heap(drizzled::plugin::StorageEngine *engine_arg,
                  TableShare *table_arg)
-  :handler(engine_arg, table_arg), file(0), records_changed(0), key_stat_version(0),
+  :Cursor(engine_arg, table_arg), file(0), records_changed(0), key_stat_version(0),
   internal_table(0)
 {}
 
@@ -192,9 +192,9 @@
     with '\'-delimited path.
 */
 
-handler *ha_heap::clone(MEM_ROOT *mem_root)
+Cursor *ha_heap::clone(MEM_ROOT *mem_root)
 {
-  handler *new_handler= table->s->db_type()->getCursor(table->s, mem_root);
+  Cursor *new_handler= table->s->db_type()->getCursor(table->s, mem_root);
   if (new_handler && !new_handler->ha_open(table, file->s->name, table->db_stat,
                                            HA_OPEN_IGNORE_IF_LOCKED))
     return new_handler;
@@ -550,7 +550,7 @@
     The indexes might have been disabled by disable_index() before.
     The function works only if both data and indexes are empty,
     since the heap storage engine cannot repair the indexes.
-    To be sure, call handler::delete_all_rows() before.
+    To be sure, call Cursor::delete_all_rows() before.
 
   IMPLEMENTATION
     HA_KEY_SWITCH_NONUNIQ       is not implemented.

=== modified file 'plugin/heap/ha_heap.h'
--- plugin/heap/ha_heap.h	2009-09-23 19:20:45 +0000
+++ plugin/heap/ha_heap.h	2009-10-16 00:38:56 +0000
@@ -15,19 +15,19 @@
 
 
 
-/* class for the the heap handler */
+/* class for the the heap Cursor */
 
 #ifndef STORAGE_HEAP_HA_HEAP_H
 #define STORAGE_HEAP_HA_HEAP_H
 
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <mysys/thr_lock.h>
 
 typedef struct st_heap_info HP_INFO;
 typedef unsigned char *HEAP_PTR;
 
 
-class ha_heap: public handler
+class ha_heap: public Cursor
 {
   HP_INFO *file;
   key_map btree_keys;
@@ -38,7 +38,7 @@
 public:
   ha_heap(drizzled::plugin::StorageEngine *engine, TableShare *table);
   ~ha_heap() {}
-  handler *clone(MEM_ROOT *mem_root);
+  Cursor *clone(MEM_ROOT *mem_root);
 
   const char *index_type(uint32_t inx);
   enum row_type get_row_type() const;

=== modified file 'plugin/info_schema/info_schema_methods.cc'
--- plugin/info_schema/info_schema_methods.cc	2009-09-30 20:50:12 +0000
+++ plugin/info_schema/info_schema_methods.cc	2009-10-16 00:38:56 +0000
@@ -1104,7 +1104,7 @@
     char option_buff[400],*ptr;
     Table *show_table= tables->table;
     TableShare *share= show_table->s;
-    handler *file= show_table->file;
+    Cursor *file= show_table->file;
     drizzled::plugin::StorageEngine *tmp_db_type= share->db_type();
 
     if (share->tmp_table == SYSTEM_TMP_TABLE)

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2009-10-13 16:18:59 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2009-10-16 00:38:56 +0000
@@ -49,7 +49,7 @@
 
 ***********************************************************************/
 
-/* TODO list for the InnoDB handler in 5.0:
+/* TODO list for the InnoDB Cursor in 5.0:
   - Remove the flag trx->active_trans and look at trx->conc_state
   - fix savepoint functions to use savepoint storage area
   - Find out what kind of problems the OS X case-insensitivity causes to
@@ -305,7 +305,7 @@
   			/* out: 0 or error number */
   	XID	*xid);	/* in: X/Open XA transaction identification */
 
-  virtual handler *create(TableShare *table,
+  virtual Cursor *create(TableShare *table,
                           MEM_ROOT *mem_root)
   {
     return new (mem_root) ha_innobase(this, table);
@@ -589,7 +589,7 @@
 srv_conc_force_exit_innodb().
 
 DRIZZLE: Note, we didn't change this name to avoid more ifdef forking 
-         in non-handler code.
+         in non-Cursor code.
 @return	true if session is the replication thread */
 extern "C" UNIV_INTERN
 ibool
@@ -663,7 +663,7 @@
 rolling back transactions that have edited non-transactional tables.
 
 DRIZZLE: Note, we didn't change this name to avoid more ifdef forking 
-         in non-handler code.
+         in non-Cursor code.
 @return	true if non-transactional tables have been edited */
 extern "C" UNIV_INTERN
 ibool
@@ -730,7 +730,7 @@
 /********************************************************************//**
 Call this function when mysqld passes control to the client. That is to
 avoid deadlocks on the adaptive hash S-latch possibly held by session. For more
-documentation, see handler.cc.
+documentation, see Cursor.cc.
 @return	0 */
 int
 InnobaseEngine::release_temporary_latches(
@@ -899,7 +899,7 @@
 after you release the kernel_mutex.
 
 DRIZZLE: Note, we didn't change this name to avoid more ifdef forking 
-         in non-handler code.
+         in non-Cursor code.
  */
 extern "C" UNIV_INTERN
 void
@@ -917,7 +917,7 @@
 released before this function is invoked. 
 
 DRIZZLE: Note, we didn't change this name to avoid more ifdef forking 
-         in non-handler code.
+         in non-Cursor code.
 */
 extern "C" UNIV_INTERN
 void
@@ -1282,7 +1282,7 @@
 }
 
 /*********************************************************************//**
-Allocates an InnoDB transaction for a MySQL handler object.
+Allocates an InnoDB transaction for a MySQL Cursor object.
 @return	InnoDB transaction handle */
 extern "C" UNIV_INTERN
 trx_t*
@@ -1306,7 +1306,7 @@
 }
 
 /*********************************************************************//**
-Gets the InnoDB transaction handle for a MySQL handler object, creates
+Gets the InnoDB transaction handle for a MySQL Cursor object, creates
 an InnoDB transaction struct if the corresponding MySQL thread struct still
 lacks one.
 @return	InnoDB transaction handle */
@@ -1334,11 +1334,11 @@
 
 
 /*********************************************************************//**
-Construct ha_innobase handler. */
+Construct ha_innobase Cursor. */
 UNIV_INTERN
 ha_innobase::ha_innobase(drizzled::plugin::StorageEngine *engine_arg,
                          TableShare *table_arg)
-  :handler(engine_arg, table_arg),
+  :Cursor(engine_arg, table_arg),
   int_table_flags(HA_REC_NOT_IN_SEQ |
 		  HA_NULL_IN_KEY |
 		  HA_CAN_INDEX_BLOBS |
@@ -1356,7 +1356,7 @@
 {}
 
 /*********************************************************************//**
-Destruct ha_innobase handler. */
+Destruct ha_innobase Cursor. */
 UNIV_INTERN
 ha_innobase::~ha_innobase()
 {
@@ -2486,7 +2486,7 @@
 Get the table flags to use for the statement.
 @return	table flags */
 UNIV_INTERN
-handler::Table_flags
+Cursor::Table_flags
 ha_innobase::table_flags() const
 /*============================*/
 {
@@ -4362,7 +4362,7 @@
 	return;
 }
 
-/* See handler.h and row0mysql.h for docs on this function. */
+/* See Cursor.h and row0mysql.h for docs on this function. */
 UNIV_INTERN
 bool
 ha_innobase::was_semi_consistent_read(void)
@@ -4371,7 +4371,7 @@
 	return(prebuilt->row_read_type == ROW_READ_DID_SEMI_CONSISTENT);
 }
 
-/* See handler.h and row0mysql.h for docs on this function. */
+/* See Cursor.h and row0mysql.h for docs on this function. */
 UNIV_INTERN
 void
 ha_innobase::try_semi_consistent_read(bool yes)
@@ -4512,7 +4512,7 @@
  (b) we also release possible 'SQL statement level resources' InnoDB may
 have for this SQL statement. The MySQL interpreter does NOT execute
 autocommit for pure read transactions, though it should. That is why the
-table handler in that case has to execute the COMMIT in ::external_lock.
+table Cursor in that case has to execute the COMMIT in ::external_lock.
 
   B) If the user has explicitly set MySQL table level locks, then MySQL
 does NOT call ::external_lock at the start of the statement. To determine
@@ -6377,7 +6377,7 @@
 
 	if (index != table->s->primary_key) {
 		/* Not clustered */
-		return(handler::read_time(index, ranges, rows));
+		return(Cursor::read_time(index, ranges, rows));
 	}
 
 	if (rows <= 2) {
@@ -7056,7 +7056,7 @@
 }
 
 /*******************************************************************//**
-Tells something additional to the handler about how to do things.
+Tells something additional to the Cursor about how to do things.
 @return	0 or error number */
 UNIV_INTERN
 int
@@ -8054,7 +8054,7 @@
 	return(0);
 }
 
-/* See comment in handler.cc */
+/* See comment in Cursor.cc */
 UNIV_INTERN
 bool
 ha_innobase::get_error_message(int, String *buf)
@@ -9098,7 +9098,7 @@
   int res;
   //if (!eq_range_arg)
     //in_range_read= TRUE;
-  res= handler::read_range_first(start_key, end_key, eq_range_arg, sorted);
+  res= Cursor::read_range_first(start_key, end_key, eq_range_arg, sorted);
   //if (res)
   //  in_range_read= FALSE;
   return res;
@@ -9107,7 +9107,7 @@
 
 int ha_innobase::read_range_next()
 {
-  int res= handler::read_range_next();
+  int res= Cursor::read_range_next();
   //if (res)
   //  in_range_read= FALSE;
   return res;

=== modified file 'plugin/innobase/handler/ha_innodb.h'
--- plugin/innobase/handler/ha_innodb.h	2009-10-13 06:36:19 +0000
+++ plugin/innobase/handler/ha_innodb.h	2009-10-16 00:38:56 +0000
@@ -19,14 +19,14 @@
 /*
   This file is based on ha_berkeley.h of MySQL distribution
 
-  This file defines the Innodb handler: the interface between MySQL and
+  This file defines the Innodb Cursor: the interface between MySQL and
   Innodb
 */
 
 #ifndef INNODB_HANDLER_HA_INNODB_H
 #define INNODB_HANDLER_HA_INNODB_H
 
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <mysys/thr_lock.h>
 
 /** InnoDB table share */
@@ -52,7 +52,7 @@
 typedef struct row_prebuilt_struct row_prebuilt_t;
 
 /** The class defining a handle to an Innodb table */
-class ha_innobase: public handler
+class ha_innobase: public Cursor
 {
 	row_prebuilt_t*	prebuilt;	/*!< prebuilt struct in InnoDB, used
 					to save CPU time with prebuilt data
@@ -241,7 +241,7 @@
 
 typedef struct trx_struct trx_t;
 /********************************************************************//**
-@file handler/ha_innodb.h
+@file Cursor/ha_innodb.h
 Converts an InnoDB error code to a MySQL error code and also tells to MySQL
 about a possible transaction rollback inside InnoDB caused by a lock wait
 timeout or a deadlock.
@@ -255,7 +255,7 @@
 	Session		*session);	/*!< in: user thread handle or NULL */
 
 /*********************************************************************//**
-Allocates an InnoDB transaction for a MySQL handler object.
+Allocates an InnoDB transaction for a MySQL Cursor object.
 @return	InnoDB transaction handle */
 extern "C" UNIV_INTERN
 trx_t*

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2009-10-12 06:15:02 +0000
+++ plugin/myisam/ha_myisam.cc	2009-10-16 00:38:56 +0000
@@ -62,7 +62,7 @@
                                      HTON_TEMPORARY_ONLY | 
                                      HTON_FILE_BASED ) {}
 
-  virtual handler *create(TableShare *table,
+  virtual Cursor *create(TableShare *table,
                           MEM_ROOT *mem_root)
   {
     return new (mem_root) ha_myisam(this, table);
@@ -455,7 +455,7 @@
 
 ha_myisam::ha_myisam(drizzled::plugin::StorageEngine *engine_arg,
                      TableShare *table_arg)
-  : handler(engine_arg, table_arg),
+  : Cursor(engine_arg, table_arg),
     file(0),
     int_table_flags(HA_NULL_IN_KEY |
                     HA_DUPLICATE_POS |
@@ -469,9 +469,9 @@
      can_enable_indexes(1)
 {}
 
-handler *ha_myisam::clone(MEM_ROOT *mem_root)
+Cursor *ha_myisam::clone(MEM_ROOT *mem_root)
 {
-  ha_myisam *new_handler= static_cast <ha_myisam *>(handler::clone(mem_root));
+  ha_myisam *new_handler= static_cast <ha_myisam *>(Cursor::clone(mem_root));
   if (new_handler)
     new_handler->file->state= file->state;
   return new_handler;
@@ -798,7 +798,7 @@
     Enable indexes, which might have been disabled by disable_index() before.
     The modes without _SAVE work only if both data and indexes are empty,
     since the MyISAM repair would enable them persistently.
-    To be sure in these cases, call handler::delete_all_rows() before.
+    To be sure in these cases, call Cursor::delete_all_rows() before.
 
   IMPLEMENTATION
     HA_KEY_SWITCH_NONUNIQ       is not implemented.
@@ -1091,7 +1091,7 @@
   //if (!eq_range_arg)
   //  in_range_read= true;
 
-  res= handler::read_range_first(start_key, end_key, eq_range_arg, sorted);
+  res= Cursor::read_range_first(start_key, end_key, eq_range_arg, sorted);
 
   //if (res)
   //  in_range_read= false;
@@ -1101,7 +1101,7 @@
 
 int ha_myisam::read_range_next()
 {
-  int res= handler::read_range_next();
+  int res= Cursor::read_range_next();
   //if (res)
   //  in_range_read= false;
   return res;

=== modified file 'plugin/myisam/ha_myisam.h'
--- plugin/myisam/ha_myisam.h	2009-10-08 13:34:44 +0000
+++ plugin/myisam/ha_myisam.h	2009-10-16 00:38:56 +0000
@@ -17,10 +17,10 @@
 #ifndef STORAGE_MYISAM_HA_MYISAM_H
 #define STORAGE_MYISAM_HA_MYISAM_H
 
-#include <drizzled/handler.h>
+#include <drizzled/cursor.h>
 #include <mysys/thr_lock.h>
 
-/* class for the the myisam handler */
+/* class for the the myisam Cursor */
 
 #include <plugin/myisam/myisam.h>
 
@@ -38,7 +38,7 @@
 }
 #endif
 
-class ha_myisam: public handler
+class ha_myisam: public Cursor
 {
   MI_INFO *file;
   uint64_t int_table_flags;
@@ -49,7 +49,7 @@
  public:
   ha_myisam(drizzled::plugin::StorageEngine *engine, TableShare *table_arg);
   ~ha_myisam() {}
-  handler *clone(MEM_ROOT *mem_root);
+  Cursor *clone(MEM_ROOT *mem_root);
   const char *index_type(uint32_t key_number);
   uint64_t table_flags() const { return int_table_flags; }
   int index_init(uint32_t idx, bool sorted);

